classification
Title: raise AttributeError if loading fails in ctypes.LibraryLoader.__getattr__
Type: behavior Stage: patch review
Components: ctypes Versions: Python 3.10, Python 3.9, Python 3.8
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: ateeq, eryksun, lfriedri
Priority: normal Keywords: easy, patch

Created on 2018-09-27 07:14 by lfriedri, last changed 2021-04-04 02:29 by ateeq.

Files
File name Uploaded Description Edit
34816.patch ateeq, 2021-04-04 02:29
Pull Requests
URL Status Linked Edit
PR 25177 open ateeq, 2021-04-04 02:20
Messages (5)
msg326528 - (view) Author: Lars Friedrich (lfriedri) Date: 2018-09-27 07:14
The following creates an OSError:

import ctypes
hasattr(ctypes.windll, 'test')

The expected behavior would be to return "False"
msg326556 - (view) Author: Eryk Sun (eryksun) * (Python triager) Date: 2018-09-27 12:26
ctypes.windll is an instance of ctypes.LibraryLoader, which has a __getattr__ method that calls ctypes.WinDLL(name) and caches the result as an instance attribute. I suppose with chained exceptions it's reasonable to handle OSError in __getattr__ by raising AttributeError. For example:

    class A:
        def __init__(self, name):
            raise OSError

    class B:
        def __getattr__(self, name):
            try:
                A(name)
            except OSError:
                raise AttributeError

Demo:

    >>> b = B()
    >>> b.test
    Traceback (most recent call last):
      File "<stdin>", line 4, in __getattr__
      File "<stdin>", line 3, in __init__
    OSError

    During handling of the above exception, another exception occurred:

    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
      File "<stdin>", line 6, in __getattr__
    AttributeError

    >>> hasattr(b, 'test')
    False

FYI, I recommend avoiding the cdll and windll LibraryLoader instances. I wish they were deprecated because globally caching CDLL and WinDLL instances leads to conflicts between projects that use the same shared libraries.
msg326557 - (view) Author: Lars Friedrich (lfriedri) Date: 2018-09-27 12:35
Thank you for your reply.

I am not sure if I understood correctly:
Do you suggest to modify ctypes.__init__.py so that the __getattr__ method of LibraryLoader catches the OSError and raises an AttributeError instead, as in your example?
msg389629 - (view) Author: Eryk Sun (eryksun) * (Python triager) Date: 2021-03-28 03:03
> __getattr__ method of LibraryLoader catches the OSError and 
> raises an AttributeError 

Yes. It seems no one was keen to work on this. I think it's relatively easy, so I'll add that flag in case someone is looking for an easy issue.
msg390168 - (view) Author: Ateeq Sharfuddin (ateeq) * Date: 2021-04-04 02:29
First patch fixing only the issue at hand on master. LibraryLoader now catches OSError for FileNotFoundError and raises AttributeError.
History
Date User Action Args
2021-04-04 02:29:42ateeqsetfiles: + 34816.patch

messages: + msg390168
2021-04-04 02:20:53ateeqsetkeywords: + patch
nosy: + ateeq

pull_requests: + pull_request23918
stage: test needed -> patch review
2021-03-28 03:03:27eryksunsetkeywords: + easy

title: ctypes + hasattr -> raise AttributeError if loading fails in ctypes.LibraryLoader.__getattr__
messages: + msg389629
versions: + Python 3.9, Python 3.10, - Python 3.7
2018-09-27 12:35:06lfriedrisetmessages: + msg326557
2018-09-27 12:26:26eryksunsetversions: + Python 3.8
nosy: + eryksun

messages: + msg326556

stage: test needed
2018-09-27 07:14:17lfriedricreate